//
// See license.txt
//
package lv.tsi.ai;

import java.text.DecimalFormat;
import java.util.Random;

import lv.tsi.util.SynthNote;

/**
 * Simple music generation using fractals.
 *
 * @version 0.1.0 6 March 2001
 * @author Alexey Vasilyev
 */
public class TestFractals {

    public static int numOnes(int in) {
        //    S    r    
        int  i,  r;
        for ( r = i = 0; i < 5; i++ ) {
            if ((in & 0x1) == 1)
               r++;
            in>>=1;         /*    */ 
        }
        return r;
    }

////////////////////////////
    public static void main(String s[]) {

        SynthNote syn = new SynthNote();
        //syn.duration = 5;
        //syn.notes_delta = 60;
        System.out.println("Playing");
        syn.createNewMelody();
        for (int i=0; i<16;i++) {
            int k = numOnes(i);
            syn.addNote( notes[k] );
        }
	syn.startPlaying();
        try {
            Thread.currentThread().sleep( 10000 );
        } catch (InterruptedException e) {}
        syn.close();
    }
                // C D E F G A  B  C
   static int[] notes = {1,3,5,6,8,10,12,13,14,15,16};

}