//
// See license.txt
//
package lv.tsi.ai;

import java.text.DecimalFormat;
import java.util.Random;

/**
 *  ,    
 *        
 *
 * struct PopStr {
 *     char Genome [L + 1];
 *     double Fitness;
 * } Pop[PopSize], NewPop[PopSize];
 *
 * // 
 *
 * GenerateRandomPopulation (Pop);
 * EvaluatePopulation (Pop);
 * while (Not_Done) (
 *     DoTournamentSelection (Pop, NewPop);
 *     ModifyPopulation (NewPop);
 *     Switch (Pop, NewPop);
 *     EvaluatePopulation (Pop);
 * }
 *
 * @version 0.1.0 6 March 2001
 * @author Alexey Vasilyev
 */
public class TestFunc {

    private final static int GENERATIONS_NUMBER = 50; // Number of iteractions
    private final static int POP_SIZE           = 10; // Number of populations
    private final static int GENOME_SIZE        = 6; // Number of bits in genome code

    private static void initPopStr(PopStrA[] pop) {
        for (int i=0; i<POP_SIZE; i++)
             pop[i] = new PopStrFunc(GENOME_SIZE);
    }

////////////////////////////
    public static void main(String s[]) {
        GeneticAlgorithm ga = new GeneticAlgorithm();
        //GeneticAlgorithm ga = new GeneticAlgorithm(POP_SIZE, GENOME_SIZE);
        PopStrA[] pop = new PopStrFunc[POP_SIZE];
        PopStrA[] newPop;
        initPopStr( pop );
        ga.GenerateRandomPopulation (pop);
        ga.EvaluatePopulation (pop);
        ga.Dump(pop);
        int i = GENERATIONS_NUMBER;
        while (i-- > 0) {
            System.out.println("\nGeneration: " + (GENERATIONS_NUMBER-i) ) ;
            initPopStr(newPop = new PopStrFunc[POP_SIZE]);
            //ga.DoTournamentSelection (pop, newPop);
            ga.DoReproduction(pop, newPop);
            ga.ModifyPopulation (newPop);
            ga.Switch (pop, newPop);
            ga.EvaluatePopulation(pop);
            ga.Dump(pop);
        }
        //System.out.println( "x: "+ PopStrFunc.mapStringToX("000001".toCharArray()) + "  y: " + PopStrFunc.func(PopStrFunc.mapStringToX("000001".toCharArray())) );
    }

}