//
// See license.txt
//
package lv.tsi.ai;

/**
 * Function specific.
 *
 * @version 0.1.0 6 March 2001
 * @author Alexey Vasilyev
 */
public class PopStrFunc extends PopStrA {

    /** Scale factor **/
    //public final static double scalefactor = 
    //    Math.PI / Math.pow((double) 2.0, (double) GENOME_SIZE);

    public PopStrFunc(int genome_size) {
        super(genome_size);
    }

    public void recalculateFitness() {
        fitness = func( mapStringToX( genome ) );
    }

    protected PopStrA createInstance() {
        return new PopStrFunc(genome.length);
    }

    /**
     * Our test function.
     */
    public static double func(double x) {
        //return x + Math.abs ( Math.sin( 32*x ) );
        //return (x-3)*(x-3)+3;
    double d;
    //d = -(x-3)*(x-3)+3;
    d = -x*x + 63*x;
    if (d>=0) return d;
    // we can't use negative numbers
    return 0;
    }

    /**
     *   -   楯窠 ।⠢
     * 祭 .
     */
    public static double mapStringToX (char[] S) {
        //    S  ࠢ  r  ᤢ  
        int  i,  r;
        for ( r = i = 0; i < S.length; ) {
            r<<=1;           /* ᤢ ⮢ ,  0  ࠢ  */ 
            if (S[i++]=='1') /* ᫨  S 1,  ... */ 
                ++r;         /*  ᠬ ࠢ   1 */
        }
        if (r<0) System.out.println("Error:" + r);
        return ((double) r );//* scalefactor);
    }

}
